<?php
/**
* ajax异步提交登录验证模块
*/
session_start();

require_once '../../../../init.php';
$is_kl_sendmail = is_file(EMLOG_ROOT.'/content/plugins/kl_sendmail/kl_sendmail.php') ? true : false;
//载入站点配置
require_once 'config.php';
$CACHE->updateCache('options');
if($is_kl_sendmail ){
require_once(EMLOG_ROOT.'/content/plugins/kl_sendmail/kl_sendmail_config.php');
require_once(EMLOG_ROOT.'/content/plugins/kl_sendmail/class/class.smtp.php');
require_once(EMLOG_ROOT.'/content/plugins/kl_sendmail/class/class.phpmailer.php');
}else{
if (Option::EMLOG_VERSION == '6.0.1'){
require_once(EMLOG_ROOT.'/include/lib/phpmailer.php');
require_once(EMLOG_ROOT.'/include/lib/smtp.php');
}
}
$Tconfig = unserialize($Tconfig);
/********************************yiwan *****************************/
/* *
 * 支付宝接口公用函数
 * 详细：该类是请求、通知返回两个文件所调用的公用函数核心处理文件
 * 版本：3.3
 * 日期：2012-07-19
 * 说明：
 * 以下代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写,并非一定要使用该代码。
 * 该代码仅供学习和研究支付宝接口使用，只是提供一个参考。
 */

/**
 * 把数组所有元素，按照“参数=参数值”的模式用“&”字符拼接成字符串
 * @param $para 需要拼接的数组
 * return 拼接完成以后的字符串
 */
function createLinkstring($para) {
    $arg  = "";
    while (list ($key, $val) = each ($para)) {
        $arg.=$key."=".$val."&";
    }
    //去掉最后一个&字符
    $arg = substr($arg,0,count($arg)-2);
    
    //如果存在转义字符，那么去掉转义
    if(get_magic_quotes_gpc()){$arg = stripslashes($arg);}
    
    return $arg;
}
/**
 * 把数组所有元素，按照“参数=参数值”的模式用“&”字符拼接成字符串，并对字符串做urlencode编码
 * @param $para 需要拼接的数组
 * return 拼接完成以后的字符串
 */
function createLinkstringUrlencode($para) {
    $arg  = "";
    while (list ($key, $val) = each ($para)) {
        $arg.=$key."=".urlencode($val)."&";
    }
    //去掉最后一个&字符
    $arg = substr($arg,0,count($arg)-2);
    
    //如果存在转义字符，那么去掉转义
    if(get_magic_quotes_gpc()){$arg = stripslashes($arg);}
    
    return $arg;
}
/**
 * 除去数组中的空值和签名参数
 * @param $para 签名参数组
 * return 去掉空值与签名参数后的新签名参数组
 */
function paraFilter($para) {
    $para_filter = array();
    while (list ($key, $val) = each ($para)) {
        if($key == "sign" || $key == "sign_type" || $val == "")continue;
        else    $para_filter[$key] = $para[$key];
    }
    return $para_filter;
}
/**
 * 对数组排序
 * @param $para 排序前的数组
 * return 排序后的数组
 */
function argSort($para) {
    ksort($para);
    reset($para);
    return $para;
}
/**
 * 写日志，方便测试（看网站需求，也可以改成把记录存入数据库）
 * 注意：服务器需要开通fopen配置
 * @param $word 要写入日志里的文本内容 默认值：空值
 */
function logResult($word='') {
    $fp = fopen("log.txt","a");
    flock($fp, LOCK_EX) ;
    fwrite($fp,"执行日期：".strftime("%Y%m%d%H%M%S",time())."\n".$word."\n");
    flock($fp, LOCK_UN);
    fclose($fp);
}

/**
 * 远程获取数据，POST模式
 * 注意：
 * 1.使用Crul需要修改服务器中php.ini文件的设置，找到php_curl.dll去掉前面的";"就行了
 * 2.文件夹中cacert.pem是SSL证书请保证其路径有效，目前默认路径是：getcwd().'\\cacert.pem'
 * @param $url 指定URL完整路径地址
 * @param $cacert_url 指定当前工作目录绝对路径
 * @param $para 请求的数据
 * @param $input_charset 编码格式。默认值：空值
 * return 远程输出的数据
 */
function getHttpResponsePOST($url, $cacert_url, $para, $input_charset = '') {

    if (trim($input_charset) != '') {
        $url = $url."_input_charset=".$input_charset;
    }
    $curl = curl_init($url);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, true);//SSL证书认证
    curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2);//严格认证
    curl_setopt($curl, CURLOPT_CAINFO,$cacert_url);//证书地址
    curl_setopt($curl, CURLOPT_HEADER, 0 ); // 过滤HTTP头
    curl_setopt($curl,CURLOPT_RETURNTRANSFER, 1);// 显示输出结果
    curl_setopt($curl,CURLOPT_POST,true); // post传输数据
    curl_setopt($curl,CURLOPT_POSTFIELDS,$para);// post传输数据
    $responseText = curl_exec($curl);
    //var_dump( curl_error($curl) );//如果执行curl过程中出现异常，可打开此开关，以便查看异常内容
    curl_close($curl);
    
    return $responseText;
}

/**
 * 远程获取数据，GET模式
 * 注意：
 * 1.使用Crul需要修改服务器中php.ini文件的设置，找到php_curl.dll去掉前面的";"就行了
 * 2.文件夹中cacert.pem是SSL证书请保证其路径有效，目前默认路径是：getcwd().'\\cacert.pem'
 * @param $url 指定URL完整路径地址
 * @param $cacert_url 指定当前工作目录绝对路径
 * return 远程输出的数据
 */
function getHttpResponseGET($url,$cacert_url) {
    $curl = curl_init($url);
    curl_setopt($curl, CURLOPT_HEADER, 0 ); // 过滤HTTP头
    curl_setopt($curl,CURLOPT_RETURNTRANSFER, 1);// 显示输出结果
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, true);//SSL证书认证
    curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2);//严格认证
    curl_setopt($curl, CURLOPT_CAINFO,$cacert_url);//证书地址
    $responseText = curl_exec($curl);
    //var_dump( curl_error($curl) );//如果执行curl过程中出现异常，可打开此开关，以便查看异常内容
    curl_close($curl);
    
    return $responseText;
}

/**
 * 实现多种字符编码方式
 * @param $input 需要编码的字符串
 * @param $_output_charset 输出的编码格式
 * @param $_input_charset 输入的编码格式
 * return 编码后的字符串
 */
function charsetEncode($input,$_output_charset ,$_input_charset) {
    $output = "";
    if(!isset($_output_charset) )$_output_charset  = $_input_charset;
    if($_input_charset == $_output_charset || $input ==null ) {
        $output = $input;
    } elseif (function_exists("mb_convert_encoding")) {
        $output = mb_convert_encoding($input,$_output_charset,$_input_charset);
    } elseif(function_exists("iconv")) {
        $output = iconv($_input_charset,$_output_charset,$input);
    } else die("sorry, you have no libs support for charset change.");
    return $output;
}
/**
 * 实现多种字符解码方式
 * @param $input 需要解码的字符串
 * @param $_output_charset 输出的解码格式
 * @param $_input_charset 输入的解码格式
 * return 解码后的字符串
 */
function charsetDecode($input,$_input_charset ,$_output_charset) {
    $output = "";
    if(!isset($_input_charset) )$_input_charset  = $_input_charset ;
    if($_input_charset == $_output_charset || $input ==null ) {
        $output = $input;
    } elseif (function_exists("mb_convert_encoding")) {
        $output = mb_convert_encoding($input,$_output_charset,$_input_charset);
    } elseif(function_exists("iconv")) {
        $output = iconv($_input_charset,$_output_charset,$input);
    } else die("sorry, you have no libs support for charset changes.");
    return $output;
}
function md5Sign($prestr, $key) {
    $prestr = $prestr . $key;
    return md5($prestr);
}

/**
 * 验证签名
 * @param $prestr 需要签名的字符串
 * @param $sign 签名结果
 * @param $key 私钥
 * return 签名结果
 */
function md5Verify($prestr, $sign, $key) {
    $prestr = $prestr . $key;
    $mysgin = md5($prestr);

    if($mysgin == $sign) {
        return true;
    }
    else {
        return false;
    }
}
/**
 * 生成要请求给支付宝的参数数组
 * @param $para_temp 请求前的参数数组
 * @return 要请求的参数数组
 */
function buildRequestPara($para_temp) {
    //除去待签名参数数组中的空值和签名参数
    $para_filter = paraFilter($para_temp);

    //对待签名参数数组排序
    $para_sort = argSort($para_filter);

    //生成签名结果
    $mysign = buildRequestMysign($para_sort);
    
    //签名结果与签名方式加入请求提交参数组中
    $para_sort['sign'] = $mysign;
    $para_sort['sign_type'] = strtoupper(trim(strtoupper('MD5')));
    
    return $para_sort;
}

/**
 * 生成要请求给支付宝的参数数组
 * @param $para_temp 请求前的参数数组
 * @return 要请求的参数数组字符串
 */
function buildRequestParaToString($para_temp) {
    //待请求参数数组
    $para = buildRequestPara($para_temp);
    
    //把参数组中所有元素，按照“参数=参数值”的模式用“&”字符拼接成字符串，并对字符串做urlencode编码
    $request_data = createLinkstringUrlencode($para);
    
    return $request_data;
}

/**
 * 建立请求，以表单HTML形式构造（默认）
 * @param $para_temp 请求参数数组
 * @param $method 提交方式。两个值可选：post、get
 * @param $button_name 确认按钮显示文字
 * @return 提交表单HTML文本
 */
function buildRequestForm($para_temp, $method='POST', $button_name='正在跳转') {
    //待请求参数数组
    $para = buildRequestPara($para_temp);
    
    $sHtml = "<form id='alipaysubmit' name='alipaysubmit' action='http://www.yiwane.com/submit.php?_input_charset=".trim(strtolower(strtoupper('MD5')))."' method='".$method."'>";
    while (list ($key, $val) = each ($para)) {
        $sHtml.= "<input type='hidden' name='".$key."' value='".$val."'/>";
    }

    //submit按钮控件请不要含有name属性
    $sHtml = $sHtml."<input type='submit' value='".$button_name."'></form>";
    
    $sHtml = $sHtml."<script>document.forms['alipaysubmit'].submit();</script>";
    
    return $sHtml;
}
function buildRequestMysign($para_sort) {
	global $Tconfig;
    //把数组所有元素，按照“参数=参数值”的模式用“&”字符拼接成字符串
    $prestr = createLinkstring($para_sort);
    
    $mysign = md5Sign($prestr, $Tconfig['sh_appkey']);

    return $mysign;
}
function getSignVeryfy($para_temp, $sign) {
	global $Tconfig;
    //除去待签名参数数组中的空值和签名参数
    $para_filter = paraFilter($para_temp);
    
    //对待签名参数数组排序
    $para_sort = argSort($para_filter);
    
    //把数组所有元素，按照“参数=参数值”的模式用“&”字符拼接成字符串
    $prestr = createLinkstring($para_sort);
    
    $isSgin = false;
    $isSgin = md5Verify($prestr, $sign, $Tconfig['sh_appkey']);
    
    return $isSgin;
}
if ($_GET['a'] == 'yiwan_pay') {

	if($Tconfig["sh_appid"] == '' || $Tconfig["sh_appkey"] == ''){
		$json  = array('code' => '200','data' => '续费'.$time['name'].$leveltype['name'].'VIP成功');
		echo json_encode($json);
		exit();
	}
	$alipay_config = array();
    //商户ID
    $alipay_config['partner']       = $Tconfig["sh_appid"];
    //商户KEY
    $alipay_config['key']           = $Tconfig["sh_appkey"];
    //签名方式 不需修改
    $alipay_config['sign_type']    = strtoupper('MD5');
    //字符编码格式 目前支持 gbk 或 utf-8
    $alipay_config['input_charset']= strtolower('utf-8');
    //访问模式,根据自己的服务器是否支持ssl访问，若支持请选择https；若不支持请选择http
    $alipay_config['transport']    = 'http';
    //支付API地址
    $alipay_config['apiurl']    = 'http://www.yiwane.com/';
    
    $out_trade_no = time().'U'.UID;
    $money = intval($_POST['money']);
    if($money == '') exit('请输入任意充值金额');
    if($money < 1 || $money >= 500) exit('金额不合法');

    $name = $blogname."充值 $money 元";
    //构造要请求的参数数组，无需改动
     
    $parameter = array(
            "pid" => trim($Tconfig["sh_appid"]),
            "type" => isset($_POST['alipay']) ? 'alipay' : 'wxpay',
            "notify_url"    => BLOG_URL.'content/templates/FLY/inc/ajax.php?a=not',
            "return_url"    => BLOG_URL.'content/templates/FLY/inc/ajax.php?a=ret',
            "out_trade_no"  => $out_trade_no,
            "name"  => $name,
            "money" => $money,
            "sitename"  => $blogname
    );
    $html_text = buildRequestForm($parameter);
    if($html_text){
    	$leix = isset($_POST['alipay']) ? '通过支付宝'.$name : '通过微信'.$name;
    	$DB = Database::getInstance();
		$userData = $DB->query("INSERT INTO  ".DB_PREFIX."user_log (`uid` , `log` ,`type` ,`payid` , `money` , `time`)VALUES (".UID.",'$leix','1','$out_trade_no', '$money','".time()."')");
		echo $html_text;
    }
    exit();
}
if ($_GET['a'] == 'ret') {
	header('Location: /?user&record');
}
if ($_GET['a'] == 'not') {
	$DB = Database::getInstance();
	if($Tconfig["sh_appid"] == '' || $Tconfig["sh_appkey"] == ''){
		exit();
	}
    if(empty($_GET)) {//判断POST来的数组是否为空
        return false;
    } else {
    	unset($_GET['a']);
        $isSign = getSignVeryfy($_GET, $_GET["sign"]);
        $responseTxt = 'true';
        if (preg_match("/true$/i",$responseTxt) && $isSign) {
                //商户订单号
                $out_trade_no = $_GET["out_trade_no"];

                //支付宝交易号

                $trade_no = $_GET["trade_no"];

                //交易状态
                $trade_status = $_GET["trade_status"];			
				$data = $DB->once_fetch_array("SELECT COUNT(*) AS total FROM ".DB_PREFIX."user_log WHERE payid='$out_trade_no' AND status = '1'");
				if ($data['total'] > 0) {
					exit("已处理");
				}
                //处理订单
                if($trade_status == 'TRADE_SUCCESS'){
                    $mmoney = $_GET['money'];
                    $param = explode("U",$out_trade_no);
                    $userid = $param[1];
                    $data = $DB->query("UPDATE  ".DB_PREFIX."user SET `Integral` = Integral + ".$mmoney." WHERE  `uid`='$userid'");
                    if($data){
                    	$DB->query("UPDATE  ".DB_PREFIX."user_log SET `status` = '1' WHERE  `payid`='$out_trade_no'");
                    }
                }
        } else {
            echo 'NO';
        }
    }
}
//CURL
function curls($url, $timeout = '5')  
{  
    // 1. 初始化  
    $ch = curl_init();  
    // 2. 设置选项，包括URL  
    curl_setopt($ch, CURLOPT_URL, $url);  
    curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);  
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER,FALSE);	
    curl_setopt($ch, CURLOPT_HEADER, 0);  
    // 3. 执行并获取HTML文档内容  
    $info = curl_exec($ch);  
    // 4. 释放curl句柄  
    curl_close($ch);  
    return $info;  
}
//检测卡密是否存在或已被使用，存在返回卡密信息
function isKeyExist($key) {
	$DB = Database::getInstance();
	$data = $DB->once_fetch_array("SELECT * FROM ".DB_PREFIX."user_key WHERE `key`='$key'");
	if ($data && $data['stutas'] == 'n') {
		return $data;
	}else {
		return false;
	}
}
//检测用户是否存在
function isUidExist($uid) {
	$DB = Database::getInstance();
	$data = $DB->once_fetch_array("SELECT COUNT(*) AS total FROM ".DB_PREFIX."user WHERE uid='$uid'");
	if ($data['total'] > 0) {
		return true;
	}else {
		return false;
	}
}
//检测用户是否存在
function isUserExist($uid) {
	$DB = Database::getInstance();
	$data = $DB->once_fetch_array("SELECT COUNT(*) AS total FROM ".DB_PREFIX."user WHERE username='$uid'");
	if ($data['total'] > 0) {
		return true;
	}else {
		return false;
	}
}
//检测youxiang是否存在
function isemailExist($email) {
	$DB = Database::getInstance();
	$data = $DB->once_fetch_array("SELECT COUNT(*) AS total FROM ".DB_PREFIX."user WHERE email='$email'");
	if ($data['total'] > 0) {
		return true;
	}else {
		return false;
	}
}
//返回VIP时间
function get_uid_vip($uid = UID) {
	$DB = Database::getInstance();
	$row = $DB->once_fetch_array("select * from ".DB_PREFIX."user where uid=$uid");
	if($row){
		if($row['vip'] <= time()){
			return '-1';
		}
		return $row['vip'];
	}
	return false;
}
//返回用户余额
function get_uid_money($uid = UID) {
	$DB = Database::getInstance();
	$row = $DB->once_fetch_array("select * from ".DB_PREFIX."user where uid=$uid");
	if($row['Integral']){
		return $row['Integral'];
	}
	return 0;
}
//返回VIP等级
function get_uid_level($uid = UID) {
	$DB = Database::getInstance();
	$row = $DB->once_fetch_array("select * from ".DB_PREFIX."user where uid=$uid");
	if($row){
		return $row['level'];
	}
	return false;
}
//添加日志
function add_vip_log($log,$uid) {
	if($log){
		$User_Model = new User_Model();
		$auser = $User_Model->getOneUser(UID);
		$buser = $User_Model->getOneUser($uid);
		$log = $auser['username'].'('.UID.') 为 '.$buser['username'].'('.$uid.')'.$log;
		$DB = Database::getInstance();
		$userData = $DB->query("INSERT INTO  ".DB_PREFIX."user_log (`log` ,`time`)VALUES ('$log','".time()."')");
		return true;
	}
	return false;
}
//根据类型返回VIP时间
function get_time_type($time) {
	if($time == 1){
		$str = array(
			'time' => 60*60*24*31,
			'name' => '一个月'
		);
	}
	if($time == 2){
		$str = array(
			'time' => 60*60*24*31*3,
			'name' => '三个月'
		);
	}
	if($time == 3){
		$str = array(
			'time' => 60*60*24*31*12,
			'name' => '一年'
		);
	}
	return $str;
}
//根据类型返回VIP时间
function get_level_type($type) {
	if($type == 1){
		$str = array(
			'level' => 1,
			'name' => '白银'
		);
	}
	if($type == 2){
		$str = array(
			'level' => 2,
			'name' => '黄金'
		);
	}
	if($type == 3){
		$str = array(
			'level' => 3,
			'name' => '钻石'
		);
	}
	return $str;
}
function get_random_code ($length = 32, $mode = 5)  
{  
    switch ($mode) {  
        case "1":  
            $str = "1234567890";  
            break;  
        case "2":  
            $str = "abcdefghijklmnopqrstuvwxyz";  
            break;  
        case "3":  
            $str = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";  
            break;  
        case "4":  
            $str = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";  
            break;  
        case "5":  
            $str = "ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890";  
            break;  
        case "6":  
            $str = "abcdefghijklmnopqrstuvwxyz1234567890";  
            break;  
        default:  
            $str = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890";  
        break;  
    }  
    $result="";  
    $l=strlen($str);  
    for($i=0;$i < $length;$i++){  
        $num = rand(0, $l-1); //如果$i不减1,将不一定生成4位数, 因为$num = rand(0,10).会随机产生10,$str[10] 为空  
        $result .= $str[$num];  
    }  
    return $result;  
}
if ($_GET['a'] == 'qq_login') {
	$Tconfig['url'] = urlencode(BLOG_URL."content/templates/FLY/inc/ajax.php?a=callbank1");
	require_once("oauth/api_qqlogin/qqConnectAPI.php");
	$qc = new QC();
	$qc -> qq_login();
}
if ($_GET['a'] == 'qq_bangding') {
	$Tconfig['url'] = urlencode(BLOG_URL."content/templates/FLY/inc/ajax.php?a=callbank");
	require_once("oauth/api_qqlogin/qqConnectAPI.php");
	if(ISLOGIN){
		$qc = new QC();
		$qc -> qq_login();
	}else{
		exit("请登陆之后在操作！");
	}
}
if ($_GET['a'] == 'jie_bang') {
	$DB = Database::getInstance();
	$sql = 'UPDATE `' . DB_PREFIX . 'user` SET `qq_login_openid`="" WHERE  `uid`=' . UID . ';';
	$staut = $DB->query($sql);
	if($staut){
		echo json_encode(array(
                'code' => '200',
                'data' => '解绑成功'
            ));
	}else{
		echo json_encode(array(
                'code' => '206',
                'data' => '解绑失败'
            ));
	}
	die;
}
if ($_GET['a'] == 'sendcode') {
	if($Tconfig["regopen"] == 2){
		exit("注册关闭");
	}
	if(isset($_POST['code'])){
		$code = addslashes(trim($_POST['code']));
	}else{
		exit();
	}
	if(isset($_POST['email'])){
		$email = addslashes(trim($_POST['email']));
	}else{
		exit();
	}
	if(isset($_SESSION['code'])){
		$sessionCode =  $_SESSION['code'];
	}else{
		$sessionCode = '';
	}
	$pattern="/([a-z0-9]*[-_.]?[a-z0-9]+)*@([a-z0-9]*[-_]?[a-z0-9]+)+[.][a-z]{2,3}([.][a-z]{2})?/i";
	if(!preg_match($pattern,$email)){
       	$json = array(
			'code' => '208',
			'info' => '邮箱格式不正确'
		);
		unset($_SESSION['code']);
		echo json_encode($json);
		exit();
	}

	$User_Model = new User_Model();

	if(isemailExist($email)){
       	$json = array(
			'code' => '208',
			'info' => '此邮箱已被注册'
		);
		unset($_SESSION['code']);
		echo json_encode($json);
		exit();
	}
	if(!strcmp($code,$sessionCode)){
       	$json = array(
			'code' => '208',
			'info' => '验证码错误'
		);
		unset($_SESSION['code']);
		echo json_encode($json);
		exit();		
	}

	$time = date('Y-m-d H:i');
	$blogname = Option::get('blogname');
	$from = $blogname;
	$emailcode = rand(1000,9999);
	$headers = 'From: '.$from . "\r\n";
	$subject = '注册邮箱验证 - '.$blogname;
	$content = '验证码为：'.$emailcode.'。请尽快填写。如果不是您操作的本次邮件，请忽略。';
    if($is_kl_sendmail ){
    if(kl_sendmail_do(KL_MAIL_SMTP,KL_MAIL_PORT,KL_MAIL_SENDEMAIL,KL_MAIL_PASSWORD,$email,$subject, $content, $blogname)){
    	$_SESSION['regemail'] = $email;
    	$_SESSION['emailcode'] = $emailcode;
       	$json = array(
			'code' => '200',
			'info' => '发送成功'
		);
		echo json_encode($json);
		exit();
    } else {
       	$json = array(
			'code' => '208',
			'info' => '发送失败'
		);
		echo json_encode($json);
		exit();
    }}else{
    if(sendmail_do(MAIL_SMTP,MAIL_PORT,MAIL_SENDEMAIL,MAIL_PASSWORD,$email,$subject, $content, $blogname)){
    	$_SESSION['regemail'] = $email;
    	$_SESSION['emailcode'] = $emailcode;
       	$json = array(
			'code' => '200',
			'info' => '发送成功'
		);
		echo json_encode($json);
		exit();
    } else {
       	$json = array(
			'code' => '208',
			'info' => '发送失败'
		);
		echo json_encode($json);
		exit();
    }}
}
if ($_GET['a'] == 'callbank') {
	$Tconfig['url'] = BLOG_URL."content/templates/FLY/inc/ajax.php";
	require_once("oauth/api_qqlogin/qqConnectAPI.php");
	if(ISLOGIN){
		global $user_cache;
		global $CACHE;
		$qc = new QC();
		$access = $qc -> qq_callback();
		$openid = $qc -> get_openid();
		$qc = new QC($access, $openid);
		$uinfo = $qc -> get_user_info();
		if($uinfo){
			$User_Model = new User_Model();
			$User_Model->updateUser(array('qq_login_openid'=>$openid), UID);
			echo '<script>opener.bangdingok();window.close();</script>';
		}else{
			echo '<script>alert(\'绑定失败\');window.close();</script>';
		}
	}
}
if ($_GET['a'] == 'callbank1') {
	$Tconfig['url'] = BLOG_URL."content/templates/FLY/inc/ajax.php";
	require_once("oauth/api_qqlogin/qqConnectAPI.php");
	global $user_cache;
	global $CACHE;
	$qc = new QC();
	$access = $qc -> qq_callback();
	$openid = $qc -> get_openid();
	$qc = new QC($access, $openid);
	$uinfo = $qc -> get_user_info();
	$DB = Database::getInstance();
	$data = $DB->once_fetch_array("SELECT * FROM ".DB_PREFIX."user WHERE qq_login_openid='$openid'");
	if($data){
		LoginAuth::setAuthCookie($data['username']);
		if(em_is_mobile()){
			header('Location:'.BLOG_URL);
		}else{
			echo '<script>opener.qq_login_ok(0);window.close();</script>';
		}		
	}else{
		echo '<script>alert(\'登陆失败,请先进入用户中心绑定账号!\');window.close();</script>';
	}
}
//检测是否为手机
function em_is_mobile() {
    $is_mobile = '';
    if ( empty($_SERVER['HTTP_USER_AGENT']) ) {
        $is_mobile = false;
    } elseif ( strpos($_SERVER['HTTP_USER_AGENT'], 'Mobile') !== false
        || strpos($_SERVER['HTTP_USER_AGENT'], 'Android') !== false
        || strpos($_SERVER['HTTP_USER_AGENT'], 'Silk/') !== false
        || strpos($_SERVER['HTTP_USER_AGENT'], 'Kindle') !== false
        || strpos($_SERVER['HTTP_USER_AGENT'], 'BlackBerry') !== false
        || strpos($_SERVER['HTTP_USER_AGENT'], 'Opera Mini') !== false
        || strpos($_SERVER['HTTP_USER_AGENT'], 'Opera Mobi') !== false ) {
            $is_mobile = true;
    } else {
        $is_mobile = false;
    }

    return $is_mobile;
}
if ($_GET['a'] == 'ajax_author') {
	$uid = isset($_GET['id']) ? addslashes(trim($_GET['id'])) : '';
	if($uid){
		$DB = Database::getInstance();
		$userData = $DB->once_fetch_array("SELECT * FROM ".DB_PREFIX."user WHERE uid = '".$uid."'");
		$userData['username'] = htmlspecialchars($userData['username']);
		$userinfo = LoginAuth::getUserDataByLogin($userData['username']);
		if($userinfo['email'] == '') $userinfo['email'] = "-1";
		$userinfo['nickname'] = htmlspecialchars($userinfo['nickname']);
		if($userinfo['nickname'] == '') $userinfo['nickname'] = "未命名";
		if($userinfo['description'] == '') $userinfo['description'] = "这家伙很懒，什么都没写！";
		if($userinfo['level'] == 3){$userinfo['nickname'] = '<span class="author-red">'.$userinfo['nickname'].'</span>';$userinfo['level'] = '<i title="钻石会员" class="vip-level3"></i>';
		}elseif($userinfo['level'] == 2){$userinfo['nickname'] = '<span class="author-red">'.$userinfo['nickname'].'</span>';$userinfo['level'] = '<i title="黄金会员" class="vip-level2"></i>';
		}elseif($userinfo['level'] == 1){$userinfo['nickname'] = '<span class="author-red">'.$userinfo['nickname'].'</span>';$userinfo['level'] = '<i title="白银会员" class="vip-level1"></i>';
		}else{$userinfo['level'] = '<i title="普通会员" class="author-ident"></i>';}
		if($userinfo['photo']){$userinfo['photo'] = $userinfo['photo'];}else{$userinfo['photo'] = BLOG_URL.'content/templates/FLY/img/avatar.png';}
		$userinfo['comnum'] = $DB->fetch_array($DB->query("select count(*) as nums from ".DB_PREFIX."comment where mail='".$userinfo['email']."'"));
        $userinfo['comnum'] = $userinfo['comnum']['nums'];
        $userinfo['blognum'] = $DB->fetch_array($DB->query("select count(*) as nums from ".DB_PREFIX."blog where author='$uid'"));
        $userinfo['blognum'] = $userinfo['blognum']['nums'];
		echo '<div class="list-detail">	<div class="author-main">
		<dl class="author-dl">
			<dt class="author-dt">
				<div class="author-name author-l"><img src="'.$userinfo['photo'].'">'.$userinfo['nickname'].''.$userinfo['level'].'</div><div class="author-m author-r"><a href="'.BLOG_URL.'author/'.$userinfo['uid'].'" title="查看详细"><i class="fa fa-paper-plane-o"></i></a></div>
				<div class="clearfloat"></div>
			</dt>
			<dd>
				<ul class="author-ul">
					<li><div class="li-main"><strong>'.$userinfo['uid'].'</strong><span>用户</span></div></li>
					<li><div class="li-main"><strong>'.$userinfo['blognum'].'</strong><span>文章</span></div></li>
					<li><div class="li-main"><strong>'.$userinfo['comnum'].'</strong><span>评论</span></div></li>
					<div class="clearfloat"></div>
				</ul>
				<div class="author-f"><div class="author-l">'.htmlspecialchars($userinfo['description']).'</div></div>
			</dd>
		</dl>
	</div></div>';
	}
}
if ($_GET['a'] == 'paygid') {
	$gid = isset($_POST['gid']) ? addslashes(trim($_POST['gid'])) : '';
	if($gid){
		$oderinfo = array('code' => '200');
		$DB = Database::getInstance();
		$Data = $DB->once_fetch_array("SELECT * FROM ".DB_PREFIX."blog WHERE gid = '".$gid."'");
		$content = $Data['content'];
		if(preg_match_all('|\[pay money=(.*?)\]([\s\S]*?)\[\/pay\]|', $content, $hide_words)){
	        $money = $hide_words[1][0];
	        if($money){
	        	$oderinfo['title'] = '购买 '.$Data['title'].'隐藏内容';
	        	$oderinfo['payid'] = time().'U'.UID;
	        	$oderinfo['money'] = $money;
	        	$oderinfo['time'] = time();
	        	$oderinfo['mymoney'] = get_uid_money();
	        	$payinfo = $DB->query("INSERT INTO  ".DB_PREFIX."user_log (`uid` , `log` ,`type` ,`payid` ,`gid`, `money` , `time`)VALUES (".UID.",'".$oderinfo['title']."','2','".$oderinfo['payid']."','$gid','".$oderinfo['money']."','".$oderinfo['time']."')");
	        	if($payinfo){
	        		$oderinfo['time'] = date("Y-m-d H:i:s",$oderinfo['time']);
	        		echo json_encode($oderinfo);
	        	}else{
					echo json_encode(array('code' => '0'));
	        	}
	        }
		}
	}
}
if ($_GET['a'] == 'paygidok') {
	$oderid = isset($_POST['oderid']) ? addslashes(trim($_POST['oderid'])) : '';
	if($oderid){
		$usermoney = get_uid_money();
		$DB = Database::getInstance();
		$Data = $DB->once_fetch_array("SELECT * FROM ".DB_PREFIX."user_log WHERE payid = '".$oderid."'");
		if($usermoney >= $Data['money']){
	        $data = $DB->query("UPDATE  ".DB_PREFIX."user SET `Integral` = Integral - ".$Data['money']." WHERE  `uid`='".$Data['uid']."'");
            if($data){
            	$DB->query("UPDATE  ".DB_PREFIX."user_log SET `status` = '1' WHERE  `payid`='$oderid'");
            	echo json_encode(array('code' => '200','info' => '购买成功'));
            }
		}else{
			echo json_encode(array('code' => '0','info' => '余额不足'));
		}
	}
}
if ($_GET['a']=='vip') {
	$User_Model=new User_Model();
	if (isset($_POST['type'])) 
	{
	}
	else 
	{
		exit(0);
	}
	$type=addslashes(trim($_POST['type']));
	if (isset($_POST['uid'])) 
	{
	}
	else 
	{
	}
	$uid=addslashes(trim($_POST['uid']));
	if ($type=='offvip' && ROLE=='admin') 
	{
		if (isUidExist($uid)) 
		{
			$User_Model->updateUser(array('vip'=>-1,'level'=>''),$uid);
			$CACHE->updateCache();
			add_vip_log('关闭VIP成功',$uid);
			$json=array('code'=>200,'data'=>'关闭成功');
		}
		else 
		{
			$json=array('code'=>206,'data'=>'不存在的用户');
		}
	}
	if ($type=='openvip' && ROLE=='admin') 
	{
		if (isUidExist($uid)) 
		{
			$User_Model->updateUser(array('vip'=>'3471263999','level'=>3),$uid);
			$CACHE->updateCache();
			add_vip_log('开通永久钻石VIP成功',$uid);
			$json=array('code'=>200,'data'=>'开通永久钻石VIP成功');
		}
		else 
		{
			$json=array('code'=>206,'data'=>'不存在的用户');
		}
	}
	if (($type=='addvip' && ROLE=='admin')) 
	{
		if (isset($_POST['time'])) 
		{
		}
		else 
		{
		}
		$timetype=addslashes(trim($_POST['time']));
		if (($timetype==1 || $timetype==2) || $timetype==3) 
		{
			$time=get_time_type($timetype);
			$viptime=get_uid_vip($uid);
			$leveltype=get_level_type($timetype);
			if ($viptime) 
			{
				if ($viptime<=time()) 
				{
					$newtime=time()+$time['time'];
					$User_Model->updateUser(array('vip'=>$newtime,'level'=>$leveltype['level']),$uid);
					add_vip_log('开通'.$time['name'].$leveltype['name'].'VIP成功',$uid);
					$json=array('code'=>200,'data'=>'开通'.$time['name'].$leveltype['name'].'VIP成功');
				}
				else 
				{
					$leveltype=get_level_type(get_uid_level($uid));
					if ($timetype>=$leveltype['level']) 
					{
						$leveltype=get_level_type($timetype);
					}
					$newtime=$viptime+$time['time'];
					$User_Model->updateUser(array('vip'=>$newtime,'level'=>$leveltype['level']),$uid);
					add_vip_log('续费'.$time['name'].$leveltype['name'].'VIP成功',$uid);
					$json=array('code'=>200,'data'=>'续费'.$time['name'].$leveltype['name'].'VIP成功');
				}
			}
			else 
			{
				$json=array('code'=>206,'data'=>'不存在的用户');
			}
		}
		else 
		{
			$json=array('code'=>206,'data'=>'操作非法');
		}
	}
	ini_set('display_errors','On');
	error_reporting(E_ALL|E_STRICT);
  function get_sort_type($s){
      $sort = array();
      switch ($s) {
        case "vip1_y":
            $sort['level'] = '1';
            $sort['time'] = 60*60*24*31;
            break;
        case "vip2_y":
            $sort['level'] = '2';
            $sort['time'] = 60*60*24*31;
            break;
        case "vip3_y":
            $sort['level'] = '3';
            $sort['time'] = 60*60*24*31;
            break;
        case "vip1_j":
            $sort['level'] = '1';
            $sort['time'] = 60*60*24*31*3;
            break;
        case "vip2_j":
            $sort['level'] = '2';
            $sort['time'] = 60*60*24*31*3;
            break;
        case "vip3_j":
            $sort['level'] = '3';
            $sort['time'] = 60*60*24*31*3;
            break;
        case "vip1_n":
            $sort['level'] = '1';
            $sort['time'] = 60*60*24*31*12;
            break;
        case "vip2_n":
            $sort['level'] = '2';
            $sort['time'] = 60*60*24*31*12;
            break;
        case "vip3_n":
            $sort['level'] = '3';
            $sort['time'] = 60*60*24*31*12;
            break;
    }
    return $sort;
  }
	if ($type=='payviptime') 
	{
		if (isset($_POST['sort'])) 
		{
		}
		else 
		{
		}
		$sort=addslashes(trim($_POST['sort']));
		$uid=UID;
		if ($Tconfig[$sort]!='') 
		{
			$money=$Tconfig[$sort];
			$sort=get_sort_type($sort);
			$viptime=get_uid_vip($uid);
			$userlevel=get_uid_level($uid);
			$usermoney=get_uid_money();
			if ($sort) 
			{
				if ($usermoney>=$money) 
				{
					$DB=Database::getInstance();
					if ($viptime<=time()) 
					{
						$newtime=time()+$sort['time'];
						$result=$DB->query('UPDATE  '.DB_PREFIX.'user SET `Integral` = Integral - '.$money.' WHERE  `uid`=\''.UID.'\'');
						if ($result) 
						{
							$User_Model->updateUser(array('vip'=>$newtime,'level'=>$sort['level']),$uid);
							$payinfo=$DB->query('INSERT INTO  '.DB_PREFIX.'user_log (`uid` , `log` ,`type` ,`payid` ,`status`, `money` , `time`)VALUES ('.UID.',\'购买VIP\',\'2\',\''.time().'\',\'1\',\''.$money.'\',\''.time().'\')');
						}
						$json=array('code'=>200,'data'=>'开通VIP成功');
					}
					else 
					{
						if ($userlevel==$sort['level']) 
						{
							$newtime=$viptime+$sort['time'];
							$result=$DB->query('UPDATE  '.DB_PREFIX.'user SET `Integral` = Integral - '.$money.' WHERE  `uid`=\''.UID.'\'');
							if ($result) 
							{
								$User_Model->updateUser(array('vip'=>$newtime),$uid);
								$payinfo=$DB->query('INSERT INTO  '.DB_PREFIX.'user_log (`uid` , `log` ,`type` ,`payid` ,`status`, `money` , `time`)VALUES ('.UID.',\'续费VIP\',\'2\',\''.time().'\',\'1\',\''.$money.'\',\''.time().'\')');
							}
							$json=array('code'=>200,'data'=>'续费VIP成功');
						}
						else 
						{
							$json=array('code'=>'200','data'=>'您不能续费此套餐');
						}
					}
				}
				else 
				{
					$json=array('code'=>206,'data'=>'余额不足');
				}
			}
			else 
			{
				$json=array('code'=>206,'data'=>'没有你需要的套餐哦。');
			}
		}
		else 
		{
			$json=array('code'=>206,'data'=>'操作非法');
		}
	}
	if ($type=='addkey' && ROLE=='admin') 
	{
		if (isset($_POST['time'])) 
		{
		}
		else 
		{
		}
		$time=addslashes(trim($_POST['time']));
		if (isset($_POST['num'])) 
		{
		}
		else 
		{
		}
		$num=addslashes(trim($_POST['num']));
		$keynum=0;
		$i=1;
		while ($i<=$num) 
		{
			$key=get_random_code();
			$DB=Database::getInstance();
			$data=$DB->query('INSERT INTO '.DB_PREFIX.'user_key (`key` ,`type` ,`time` ,`stutas`) VALUES ( \''.$key.'\',  \''.$time.'\',  \''.time().'\', \'n\')');
			if ($data) 
			{
				$keynum=$keynum+1;
				$keylist[]=$key;
			}
			$i=$i+1;
		}
		$json=array('code'=>200,'data'=>$keynum.'张生成成功');
	}
	if ($type=='delkey' && ROLE=='admin') 
	{
		if (isset($_POST['id'])) 
		{
		}
		else 
		{
			exit(0);
		}
		$id=addslashes(trim($_POST['id']));
		if ($id=='all') 
		{
			$sql='DELETE FROM '.DB_PREFIX.'user_key';
		}
		else 
		{
			$sql='DELETE FROM '.DB_PREFIX.'user_key WHERE `id` = \''.$id.'\'';
		}
		$DB=Database::getInstance();
		$data=$DB->query($sql);
		if ($data) 
		{
			$json=array('code'=>200,'data'=>'删除成功');
		}
		else 
		{
			$json=array('code'=>206,'data'=>'删除失败');
		}
	}
	if ($type=='dellog' && ROLE=='admin') 
	{
		$DB=Database::getInstance();
		$data=$DB->query('DELETE FROM '.DB_PREFIX.'user_log');
		if ($data) 
		{
			$json=array('code'=>200,'data'=>'清空日志成功');
		}
		else 
		{
			$json=array('code'=>'206','data'=>'清空日志失败');
		}
	}
	if ($type=='payvip') 
	{
		if (isset($_POST['key'])) 
		{
		}
		else 
		{
		}
		$key=addslashes(trim($_POST['key']));
		if ($key=='') 
		{
			$json=array('code'=>206,'data'=>'卡密不能为空');
		}
		else 
		{
			$keyinfo=isKeyExist($key);
			if ($keyinfo && strlen($key)==32) 
			{
				$time=get_time_type($keyinfo['type']);
				$viptime=get_uid_vip(UID);
				$leveltype=get_level_type($keyinfo['type']);
				if ($viptime) 
				{
					if ($viptime<=time()) 
					{
						$newtime=time()+$time['time'];
						$User_Model->updateUser(array('vip'=>$newtime,'level'=>$leveltype['level']),UID);
						$DB=Database::getInstance();
						$data=$DB->query('UPDATE  '.DB_PREFIX.'user_key SET `stutas` =  \'y\' WHERE  `key` =\''.$key.'\'');
						add_vip_log('通过卡密'.$key.'开通'.$time['name'].$leveltype['name'].'VIP成功',UID);
						$json=array('code'=>'200','data'=>'成功开通'.$time['name'].'并成为了本站'.$leveltype['name'].'VIP');
					}
					else 
					{
						$leveltype=get_level_type(get_uid_level(UID));
						$newtime=$viptime+$time['time'];
						$User_Model->updateUser(array('vip'=>$newtime,'level'=>$leveltype['level']),UID);
						$DB=Database::getInstance();
						$data=$DB->query('UPDATE  '.DB_PREFIX.'user_key SET `stutas` =  \'y\' WHERE  `key` =\''.$key.'\'');
						add_vip_log('通过卡密'.$key.'续费'.$time['name'].$leveltype['name'].'VIP成功',UID);
						$json=array('code'=>200,'data'=>'成功续费'.$time['name'].'并成为了本站'.$leveltype['name'].'VIP');
					}
				}
				else 
				{
					$json=array('code'=>206,'data'=>'不存在的用户');
				}
			}
			else 
			{
				$json=array('code'=>206,'data'=>'卡密有误或已被使用');
			}
		}
	}
	echo json_encode($json);
}
if ($_GET['a'] == 're') {
	if($Tconfig["regopen"] == 2){exit("注册关闭");}
	if(ROLE == 'admin' || ROLE == 'writer'){
		$json = array(
			'code' => '203',
			'info' => '您已经登录'
		);
		echo json_encode($json);
		exit();
	}
	global $CACHE;
	$options_cache = $CACHE->readCache('options');
	$DB = Database::getInstance(); 
	$username = isset($_POST['reusername']) ? addslashes(trim($_POST['reusername'])) : '';
	$email = isset($_POST['regemail']) ? addslashes(trim($_POST['regemail'])) : '';
	$password = isset($_POST['repassword']) ? addslashes(trim($_POST['repassword'])) : '';
	$password2 = isset($_POST['repassword2']) ? addslashes(trim($_POST['repassword2'])) : '';
	$imgcode = isset($_POST['code']) ? strtoupper(addslashes(trim($_POST['code']))): ''; 
    $reimgcode = isset($_POST['reimgcode']) ? strtoupper(addslashes(trim($_POST['reimgcode']))): ''; 
	$pattern="/([a-z0-9]*[-_.]?[a-z0-9]+)*@([a-z0-9]*[-_]?[a-z0-9]+)+[.][a-z]{2,3}([.][a-z]{2})?/i";
    if($Tconfig["emailclick"] == 1){ //启用邮箱验证
    	if($username && $password && $password2 && $imgcode){
    		$sessionCode = isset($_SESSION['emailcode']) ? $_SESSION['emailcode'] : '';
    		if($imgcode == $sessionCode){
    			if(preg_match($pattern,$email) && !isemailExist($email)){
    				$User_Model = new User_Model();
    				if(!isUserExist($username)){
    					$hsPWD = new PasswordHash(8, true);
    					$password = $hsPWD->HashPassword($password);
                        if (Option::EMLOG_VERSION == '6.0.1'){
                            $User_Model->addUser($username, $password, $email,'','writer', 'y');
                        }else{
                            $User_Model->addUser($username, $password,'writer', 'y');
                        }
    					$DB = Database::getInstance();
    					$data = $DB->query("UPDATE  ".DB_PREFIX."user SET `email` = '$email' WHERE  `username`='$username'");
    					$CACHE->updateCache();
    					$json = array(
    						'code' => '200',
    						'info' => '注册成功'
    					);
    				}else{
    					$json = array(
    						'code' => '201',
    						'info' => '用户名已存在'
    					);
    				}
    			}else{
    				$json = array(
    					'code' => '202',
    					'info' => '邮箱已存在或格式错误'
    				);				
    			}
    		}else{
    				$json = array(
    					'code' => '203',
    					'info' => '验证码错误'
    				);
    		}
    	}
    }else{
        if($username && $password && $password2 && $reimgcode){
            $sessionCode = isset($_SESSION['code']) ? $_SESSION['code'] : '';
            if($reimgcode == $sessionCode){
                if(preg_match($pattern,$email) && !isemailExist($email)){
                    $User_Model = new User_Model();
                    if(!isUserExist($username)){
                        $hsPWD = new PasswordHash(8, true);
                        $password = $hsPWD->HashPassword($password);
                        if (Option::EMLOG_VERSION == '6.0.1'){
                            $User_Model->addUser($username, $password, $email,'','writer', 'y');
                        }else{
                            $User_Model->addUser($username, $password,'writer', 'y');
                        }
                        $DB = Database::getInstance();
                        $data = $DB->query("UPDATE  ".DB_PREFIX."user SET `email` = '$email' WHERE  `username`='$username'");
                        $CACHE->updateCache();
                        $json = array(
                            'code' => '200',
                            'info' => '注册成功'
                        );
                    }else{
                        $json = array(
                            'code' => '201',
                            'info' => '用户名已存在'
                        );
                    }
                }else{
                    $json = array(
                        'code' => '202',
                        'info' => '邮箱已存在或格式错误'
                    );              
                }
            }else{
                    $json = array(
                        'code' => '203',
                        'info' => '验证码错误'
                    );
            }
        }
    }
	echo json_encode($json);
}
if ($_GET['a'] == 'login') {
	$username  = isset($_POST['user']) ? addslashes(trim($_POST['user'])) : '';
	$password  = isset($_POST['pw']) ? addslashes(trim($_POST['pw'])) : '';
	$ispersis  = isset($_POST['ispersis']) ? intval($_POST['ispersis']) : false;
	$img_code  = Option::get('login_code') == 'y' && isset($_POST['imgcode']) ? addslashes(trim(strtoupper($_POST['imgcode']))) : '';
	$errorCode = LoginAuth::checkUser($username, $password, $img_code);
	if ($errorCode === true) {
		LoginAuth::setAuthCookie($username, $ispersis);
		$userinfo = LoginAuth::getUserDataByLogin($username);
		$json     = array(
			'code' => '200',
			'data' => $userinfo
		);
	} else {
		switch ($errorCode) {
			case '-3':
				$json = array(
					'code' => '201',
					'info' => '验证码输入有误'
				);
				break;
			case '-1':
				$json = array(
					'code' => '202',
					'info' => '账号或密码错误'
				);
				break;
			case '-2':
				$json = array(
					'code' => '203',
					'info' => '账号或密码错误'
				);
				break;
		}
	}
	echo json_encode($json);
}
if ($_GET['a'] == 'ajax_logout') {
	setcookie(AUTH_COOKIE_NAME, ' ', time() - 31536000, '/');
}
if ($_GET['a'] == 'ajax') {
	if (ROLE == 'admin' || ROLE == 'writer') {
		$DB = Database::getInstance();
		$userData = $DB->once_fetch_array("SELECT * FROM ".DB_PREFIX."user WHERE uid = '".UID."'");
        $userData['username'] = htmlspecialchars($userData['username']);
		$userinfo = LoginAuth::getUserDataByLogin($userData['username']);
		$json     = array(
			'code' => '200',
			'data' => $userinfo
		);
	}else{
			$json = array(
				'code' => '208',
			);
	}
	echo json_encode($json);
}
if ($_GET['a'] == 'selectimage') {
    $User_Model = new User_Model();
	if (ROLE == 'admin' || ROLE == 'writer') {
        $image  = isset($_POST['image']) ? addslashes(trim($_POST['image'])) : '-1';
        if($image){
              $web_url = '../content/templates/FLY/img/tx/'.$image.'.jpg';
			  $User_Model->updateUser(array('photo'=>$web_url), UID);
              $CACHE->updateCache();
              $json     = array(
                  'code' => '200',
                  'data' =>  $web_url
              );             
        }else{
                      $json     = array(
                  'code' => '200',
                  'data' => '修改失败'
              	  );       
        }
	}else{
			$json = array(
				'code' => '208',
              'data' => '权限不足'
			);
	}
	echo json_encode($json);
}
if ($_GET['a'] == 'upimage') {
    $User_Model = new User_Model();
	if (ROLE == 'admin' || ROLE == 'writer') {
        $image  = isset($_POST['image']) ? addslashes(trim($_POST['image'])) : '-1';
        if($image && strstr($image,"data:image")){
            $dataname = time().rand(1000,10000);
            $data = explode(",",$image);
            $dataurl = EMLOG_ROOT.'/content/uploadfile/topimg/';
            if ( !file_exists($dataurl)) {
            	mkdir( "$dataurl" , 0777);
            }
            $info = file_put_contents($dataurl.$dataname.'.png', base64_decode($data[1]));
            if($info){       
              $web_url = '../content/uploadfile/topimg/'.$dataname.'.png';
			  $User_Model->updateUser(array('photo'=>$web_url), UID);
              $CACHE->updateCache();
              $json     = array(
                  'code' => '200',
                  'data' =>  $web_url
              );             
            }else{
                  $json     = array(
                  'code' => '206',
                  'data' => '上传失败'
              	  );            
            }
  
        }else{
                      $json     = array(
                  'code' => '200',
                  'data' => '上传失败'
              	  );       
        }
	}else{
			$json = array(
				'code' => '208',
              'data' => '权限不足'
			);
	}
	echo json_encode($json);
}
if($_GET['a'] == 'update'){
    LoginAuth::checkToken();
	$User_Model = new User_Model();
	$nickname = isset($_POST['name']) ? addslashes(trim($_POST['name'])) : '';
	$email = isset($_POST['email']) ? addslashes(trim($_POST['email'])) : '';
	$sex = isset($_POST['sex']) ? addslashes(trim($_POST['sex'])) : '';
	$qq = isset($_POST['qq']) ? addslashes(trim($_POST['qq'])) : '';
	$description = isset($_POST['description']) ? addslashes(trim($_POST['description'])) : '';
    $username = isset($_POST['username']) ? addslashes(trim($_POST['username'])) : '';
	$newpass = isset($_POST['newpass']) ? addslashes(trim($_POST['newpass'])) : '';
	$repeatpass = isset($_POST['repeatpass']) ? addslashes(trim($_POST['repeatpass'])) : '';

if (strlen($nickname) > 20) {
	$json = array(
		'code' => '201',
		'info' => '昵称不能太长'
	);
	echo json_encode($json);
	exit();
} else if ($email != '' && !checkMail($email)) {
	$json = array(
		'code' => '202',
		'info' => '电子邮件格式错误'
	);
	echo json_encode($json);
	exit();
} elseif (strlen($newpass)>0 && strlen($newpass) < 6) {
	$json = array(
		'code' => '204',
		'info' => '密码长度不得小于6位'
	);
	echo json_encode($json);
	exit();
} elseif (!empty($newpass) && $newpass != $repeatpass) {
	$json = array(
		'code' => '205',
		'info' => '两次输入的密码不一致'
	);
	echo json_encode($json);
	exit();
} elseif($User_Model->isUserExist($username, UID)) {
	$json = array(
		'code' => '206',
		'info' => '该登录名已存在'
	);
	echo json_encode($json);
	exit();
} elseif($User_Model->isNicknameExist($nickname, UID)) {
	$json = array(
		'code' => '207',
		'info' => '该昵称已存在'
	);
	echo json_encode($json);
	exit();
}else{
    if (!empty($newpass)) {
        $PHPASS = new PasswordHash(8, true);
        $newpass = $PHPASS->HashPassword($newpass);
        $User_Model->updateUser(array('password'=>$newpass), UID);
    }
    //if (!empty($username)) {
    //    $User_Model->updateUser(array('username'=>$username), UID);
    //}
    $User_Model->updateUser(array('nickname'=>$nickname, 'email'=>$email, 'sex'=>$sex, 'qq'=>$qq, 'description'=>$description), UID);
    $CACHE->updateCache('user');
  	$json = array(
		'code' => '200',
		'info' => '修改成功'
	);
	echo json_encode($json);
	exit();
}
}
if ($_GET['a'] == 'addlog') {
	if (ROLE == 'admin' || ROLE == 'writer') {
        $Log_Model = new Log_Model();
        global $CACHE;
        $user_cache = $CACHE->readCache('user');
		$title = isset($_POST['post_title']) ? addslashes(trim($_POST['post_title'])) : '';
		$content = isset($_POST['post_content']) ? addslashes(trim($_POST['post_content'])) : '';
		$category = isset($_POST['post_category']) ? addslashes(trim($_POST['post_category'])) : '-1';
        if (empty($title) || mb_strlen($title) > 50) {
			$json = array(
				'code' => '201',
				'info' => '标题不能为空，且小于50个字符'
			);
			echo json_encode($json);
			exit();
        }
        if (empty($content) || mb_strlen($content) > 10000 || mb_strlen($content) < 10) {
			$json = array(
				'code' => '202',
				'info' => '文章内容不能为空，且介于10-10000字之间'
			);
			echo json_encode($json);
			exit();
        }
        if (post_title($title)) {
			$json = array(
				'code' => '203',
				'info' => '标题 ' . $title . ' 已存在'
			);
			echo json_encode($json);
			exit();
        }
            $logData = array(
                'title' => $title,
                'alias' => '',
                'content' => $content,
                'author' => UID,
                'sortid' => $category,
                'date' => time(),
                'top '=> 'n',
                'sortop '=> 'n',
                'allow_remark' => 'y',
                'hide' => 'n',
                'checked' => 'n',
                'password' => ''
			);
        if (post_addlog($logData)) {
            $CACHE->updateCache('blog');
			$CACHE->updateCache('sort');
           	$json = array(
				'code' => '200',
				'info' => '发表成功,'
			);
			echo json_encode($json);
			exit();
        } else {
           	$json = array(
				'code' => '200',
				'info' => '发表失败'
			);
			echo json_encode($json);
			exit();
        }
	}
}
function post_addlog ($logData){
	$db = Database::getInstance();
	$kItem = array();
	$dItem = array();
	foreach ($logData as $key => $data) {
		$kItem[] = $key;
		$dItem[] = $data;
	}
	$field = implode(',', $kItem);
	$values = "'" . implode("','", $dItem) . "'";
	$db->query("INSERT INTO " . DB_PREFIX . "blog ($field) VALUES ($values)");
	$logid = $db->insert_id();
	return $logid;
}
function post_title($title){
	$db = Database::getInstance();
	$row=$db->once_fetch_array("SELECT * FROM  `".DB_NAME."`.`".DB_PREFIX."blog` WHERE `title` = '".$title."'");
	if($row){
		return '1';
	}
	return '0';
}
?>